## valkey 7.2.5+dfsg1

=== src/Makefile ===
# Valkey Makefile
# Copyright (C) 2009 Salvatore Sanfilippo <antirez at gmail dot com>
# This file is released under the BSD license, see the COPYING file
#
# The Makefile composes the final FINAL_CFLAGS and FINAL_LDFLAGS using
# what is needed for Valkey plus the standard CFLAGS and LDFLAGS passed.
# However when building the dependencies (Jemalloc, Lua, Hiredis, ...)
# CFLAGS and LDFLAGS are propagated to the dependencies, so to pass
# flags only to be used when compiling / linking Valkey itself SERVER_CFLAGS
# and SERVER_LDFLAGS are used instead (this is the case of 'make gcov').
#
# Dependencies are stored in the Makefile.dep file. To rebuild this file
# Just use 'make dep', but this is only needed by developers.

release_hdr := $(shell sh -c './mkreleasehdr.sh')
uname_S := $(shell sh -c 'uname -s 2>/dev/null || echo not')
uname_M := $(shell sh -c 'uname -m 2>/dev/null || echo not')
CLANG := $(findstring clang,$(shell sh -c '$(CC) --version | head -1'))
OPTIMIZATION?=-O3
ifeq ($(OPTIMIZATION),-O3)
	ifeq (clang,$(CLANG))
		SERVER_CFLAGS+=-flto
	else
		SERVER_CFLAGS+=-flto=auto
	endif
	SERVER_LDFLAGS+=-O3 -flto
endif
DEPENDENCY_TARGETS=hiredis linenoise lua hdr_histogram fpconv
NODEPS:=clean distclean

# Default settings
STD=-pedantic -DREDIS_STATIC=''

# Use -Wno-c11-extensions on clang, either where explicitly used or on
# platforms we can assume it's being used.
ifeq (clang,$(CLANG))
  STD+=-Wno-c11-extensions
else
ifneq (,$(findstring FreeBSD,$(uname_S)))
  STD+=-Wno-c11-extensions
endif
endif
WARN=-Wall -W -Wno-missing-field-initializers -Werror=deprecated-declarations -Wstrict-prototypes
OPT=$(OPTIMIZATION)

# Detect if the compiler supports C11 _Atomic.
# NUMBER_SIGN_CHAR is a workaround to support both GNU Make 4.3 and older versions.
NUMBER_SIGN_CHAR := \#
C11_ATOMIC := $(shell sh -c 'echo "$(NUMBER_SIGN_CHAR)include <stdatomic.h>" > foo.c; \
	$(CC) -std=gnu11 -c foo.c -o foo.o > /dev/null 2>&1; \
	if [ -f foo.o ]; then echo "yes"; rm foo.o; fi; rm foo.c')
ifeq ($(C11_ATOMIC),yes)
	STD+=-std=gnu11
else
	STD+=-std=c99
endif

PREFIX?=/usr/local
INSTALL_BIN=$(PREFIX)/bin
INSTALL=install
PKG_CONFIG?=pkg-config

ifndef PYTHON
PYTHON := $(shell which python3 || which python)
endif

# Default allocator defaults to Jemalloc on Linux and libc otherwise
MALLOC=libc
ifeq ($(uname_S),Linux)
	MALLOC=jemalloc
endif

# To get ARM stack traces if Valkey crashes we need a special C flag.
ifneq (,$(filter aarch64 armv%,$(uname_M)))
        CFLAGS+=-funwind-tables
endif

# Backwards compatibility for selecting an allocator
ifeq ($(USE_TCMALLOC),yes)
	MALLOC=tcmalloc
endif

ifeq ($(USE_TCMALLOC_MINIMAL),yes)
	MALLOC=tcmalloc_minimal
endif

ifeq ($(USE_JEMALLOC),yes)
	MALLOC=jemalloc
endif

ifeq ($(USE_JEMALLOC),no)
	MALLOC=libc
endif

ifdef SANITIZER
ifeq ($(SANITIZER),address)
	MALLOC=libc
	CFLAGS+=-fsanitize=address -fno-sanitize-recover=all -fno-omit-frame-pointer
	LDFLAGS+=-fsanitize=address
else
ifeq ($(SANITIZER),undefined)
	MALLOC=libc
	CFLAGS+=-fsanitize=undefined -fno-sanitize-recover=all -fno-omit-frame-pointer
	LDFLAGS+=-fsanitize=undefined
else
ifeq ($(SANITIZER),thread)
	CFLAGS+=-fsanitize=thread -fno-sanitize-recover=all -fno-omit-frame-pointer
	LDFLAGS+=-fsanitize=thread
else
    $(error "unknown sanitizer=${SANITIZER}")
endif
endif
endif
endif

# Override default settings if possible
-include .make-settings

# For added compatibility REDIS_CFLAGS and REDIS_LDFLAGS are also supported.
ifdef REDIS_CFLAGS
    SERVER_CFLAGS := $(REDIS_CFLAGS)
endif
ifdef REDIS_LDFLAGS
    SERVER_LDFLAGS := $(REDIS_LDFLAGS)
endif

FINAL_CFLAGS=$(STD) $(WARN) $(OPT) $(DEBUG) $(CFLAGS) $(SERVER_CFLAGS)
FINAL_LDFLAGS=$(LDFLAGS) $(SERVER_LDFLAGS) $(DEBUG)
FINAL_LIBS=-lm
DEBUG=-g -ggdb

# Linux ARM32 needs -latomic at linking time
ifneq (,$(findstring armv,$(uname_M)))
        FINAL_LIBS+=-latomic
endif

ifeq ($(uname_S),SunOS)
	# SunOS
	ifeq ($(findstring -m32,$(FINAL_CFLAGS)),)
		CFLAGS+=-m64
	endif
	ifeq ($(findstring -m32,$(FINAL_LDFLAGS)),)
		LDFLAGS+=-m64
	endif
	DEBUG=-g
	DEBUG_FLAGS=-g
	export CFLAGS LDFLAGS DEBUG DEBUG_FLAGS
	INSTALL=cp -pf
	FINAL_CFLAGS+= -D__EXTENSIONS__ -D_XPG6
	FINAL_LIBS+= -ldl -lnsl -lsocket -lresolv -lpthread -lrt
	ifeq ($(USE_BACKTRACE),yes)
	    FINAL_CFLAGS+= -DUSE_BACKTRACE
	endif
else
ifeq ($(uname_S),Darwin)
	# Darwin
	FINAL_LIBS+= -ldl
	# Homebrew's OpenSSL is not linked to /usr/local to avoid
	# conflicts with the system's LibreSSL installation so it
	# must be referenced explicitly during build.
ifeq ($(uname_M),arm64)
	# Homebrew arm64 uses /opt/homebrew as HOMEBREW_PREFIX
	OPENSSL_PREFIX?=/opt/homebrew/opt/openssl
else
	# Homebrew x86/ppc uses /usr/local as HOMEBREW_PREFIX
	OPENSSL_PREFIX?=/usr/local/opt/openssl
endif
else
ifeq ($(uname_S),AIX)
        # AIX
        FINAL_LDFLAGS+= -Wl,-bexpall
        FINAL_LIBS+=-ldl -pthread -lcrypt -lbsd
else
ifeq ($(uname_S),OpenBSD)
	# OpenBSD
	FINAL_LIBS+= -lpthread
	ifeq ($(USE_BACKTRACE),yes)
	    FINAL_CFLAGS+= -DUSE_BACKTRACE -I/usr/local/include
	    FINAL_LDFLAGS+= -L/usr/local/lib
	    FINAL_LIBS+= -lexecinfo
    	endif

else
ifeq ($(uname_S),NetBSD)
	# NetBSD
	FINAL_LIBS+= -lpthread
	ifeq ($(USE_BACKTRACE),yes)
	    FINAL_CFLAGS+= -DUSE_BACKTRACE -I/usr/pkg/include
	    FINAL_LDFLAGS+= -L/usr/pkg/lib
	    FINAL_LIBS+= -lexecinfo
    	endif
else
ifeq ($(uname_S),FreeBSD)
	# FreeBSD
	FINAL_LIBS+= -lpthread -lexecinfo
else
ifeq ($(uname_S),DragonFly)
	# DragonFly
	FINAL_LIBS+= -lpthread -lexecinfo
else
ifeq ($(uname_S),OpenBSD)
	# OpenBSD
	FINAL_LIBS+= -lpthread -lexecinfo
else
ifeq ($(uname_S),NetBSD)
	# NetBSD
	FINAL_LIBS+= -lpthread -lexecinfo
else
ifeq ($(uname_S),Haiku)
	# Haiku
	FINAL_CFLAGS+= -DBSD_SOURCE
	FINAL_LDFLAGS+= -lbsd -lnetwork
	FINAL_LIBS+= -lpthread
else
	# All the other OSes (notably Linux)
	FINAL_LDFLAGS+= -rdynamic
	FINAL_LIBS+=-ldl -pthread -lrt
endif
endif
endif
endif
endif
endif
endif
endif
endif
endif

ifdef OPENSSL_PREFIX
	OPENSSL_CFLAGS=-I$(OPENSSL_PREFIX)/include
	OPENSSL_LDFLAGS=-L$(OPENSSL_PREFIX)/lib
	# Also export OPENSSL_PREFIX so it ends up in deps sub-Makefiles
	export OPENSSL_PREFIX
endif

# Include paths to dependencies
FINAL_CFLAGS+= -I../deps/hiredis -I../deps/linenoise -I../deps/lua/src -I../deps/hdr_histogram -I../deps/fpconv

# Determine systemd support and/or build preference (defaulting to auto-detection)
BUILD_WITH_SYSTEMD=no
LIBSYSTEMD_LIBS=-lsystemd

# If 'USE_SYSTEMD' in the environment is neither "no" nor "yes", try to
# auto-detect libsystemd's presence and link accordingly.
ifneq ($(USE_SYSTEMD),no)
	LIBSYSTEMD_PKGCONFIG := $(shell $(PKG_CONFIG) --exists libsystemd && echo $$?)
# If libsystemd cannot be detected, continue building without support for it
# (unless a later check tells us otherwise)
ifeq ($(LIBSYSTEMD_PKGCONFIG),0)
	BUILD_WITH_SYSTEMD=yes
	LIBSYSTEMD_LIBS=$(shell $(PKG_CONFIG) --libs libsystemd)
endif
endif

# If 'USE_SYSTEMD' is set to "yes" use pkg-config if available or fall back to
# default -lsystemd.
ifeq ($(USE_SYSTEMD),yes)
	BUILD_WITH_SYSTEMD=yes
endif

ifeq ($(BUILD_WITH_SYSTEMD),yes)
	FINAL_LIBS+=$(LIBSYSTEMD_LIBS)
	FINAL_CFLAGS+= -DHAVE_LIBSYSTEMD
endif

ifeq ($(MALLOC),tcmalloc)
	FINAL_CFLAGS+= -DUSE_TCMALLOC
	FINAL_LIBS+= -ltcmalloc
endif

ifeq ($(MALLOC),tcmalloc_minimal)
	FINAL_CFLAGS+= -DUSE_TCMALLOC
	FINAL_LIBS+= -ltcmalloc_minimal
endif

ifeq ($(MALLOC),jemalloc)
	DEPENDENCY_TARGETS+= jemalloc
	FINAL_CFLAGS+= -DUSE_JEMALLOC -I../deps/jemalloc/include
	FINAL_LIBS := ../deps/jemalloc/lib/libjemalloc.a $(FINAL_LIBS)
endif

# LIBSSL & LIBCRYPTO
LIBSSL_LIBS=
LIBSSL_PKGCONFIG := $(shell $(PKG_CONFIG) --exists libssl && echo $$?)
ifeq ($(LIBSSL_PKGCONFIG),0)
	LIBSSL_LIBS=$(shell $(PKG_CONFIG) --libs libssl)
else
	LIBSSL_LIBS=-lssl
endif
LIBCRYPTO_LIBS=
LIBCRYPTO_PKGCONFIG := $(shell $(PKG_CONFIG) --exists libcrypto && echo $$?)
ifeq ($(LIBCRYPTO_PKGCONFIG),0)
	LIBCRYPTO_LIBS=$(shell $(PKG_CONFIG) --libs libcrypto)
else
	LIBCRYPTO_LIBS=-lcrypto
endif

BUILD_NO:=0
BUILD_YES:=1
BUILD_MODULE:=2
ifeq ($(BUILD_TLS),yes)
	FINAL_CFLAGS+=-DUSE_OPENSSL=$(BUILD_YES) $(OPENSSL_CFLAGS) -DBUILD_TLS_MODULE=$(BUILD_NO)
	FINAL_LDFLAGS+=$(OPENSSL_LDFLAGS)
	FINAL_LIBS += ../deps/hiredis/libhiredis_ssl.a $(LIBSSL_LIBS) $(LIBCRYPTO_LIBS)
endif

TLS_MODULE=
TLS_MODULE_NAME:=valkey-tls$(PROG_SUFFIX).so
TLS_MODULE_CFLAGS:=$(FINAL_CFLAGS)
ifeq ($(BUILD_TLS),module)
	FINAL_CFLAGS+=-DUSE_OPENSSL=$(BUILD_MODULE) $(OPENSSL_CFLAGS)
	TLS_CLIENT_LIBS = ../deps/hiredis/libhiredis_ssl.a $(LIBSSL_LIBS) $(LIBCRYPTO_LIBS)
	TLS_MODULE=$(TLS_MODULE_NAME)
	TLS_MODULE_CFLAGS+=-DUSE_OPENSSL=$(BUILD_MODULE) $(OPENSSL_CFLAGS) -DBUILD_TLS_MODULE=$(BUILD_MODULE)
endif

ifndef V
    define MAKE_INSTALL
        @printf '    %b %b\n' $(LINKCOLOR)INSTALL$(ENDCOLOR) $(BINCOLOR)$(1)$(ENDCOLOR) 1>&2
        @$(INSTALL) $(1) $(2)
    endef

    define INSTALL_REDIS_SYMLINK
        @printf '    %b %b %b %b %b %b %b\n' \
        $(LINKCOLOR)INSTALL SYMLINK$(ENDCOLOR) \
        $(BINCOLOR)$(subst $(ENGINE_NAME),redis,$(1))$(ENDCOLOR) -\> $(BINCOLOR)$(1)$(ENDCOLOR) 1>&2
        @ln -sf $(1) $(2)/$(subst $(ENGINE_NAME),redis,$(1))
    endef
else
    define MAKE_INSTALL
        $(INSTALL) $(1) $(2)
    endef

    define INSTALL_REDIS_SYMLINK
        ln -sf $(1) $(2)/$(subst $(ENGINE_NAME),redis,$(1))
    endef
endif

# Determine install/uninstall Redis symlinks for compatibility when 
# installing/uninstalling Valkey binaries (defaulting to `yes`)
USE_REDIS_SYMLINKS?=yes
ifeq ($(USE_REDIS_SYMLINKS),yes)
	MAYBE_INSTALL_REDIS_SYMLINK=$(INSTALL_REDIS_SYMLINK)
	MAYBE_UNINSTALL_REDIS_SYMLINK=@rm -f $(1)/$(subst $(ENGINE_NAME),redis,$(2))
	FINAL_CFLAGS+= -DUSE_REDIS_SYMLINKS
else
	MAYBE_INSTALL_REDIS_SYMLINK=
	MAYBE_UNINSTALL_REDIS_SYMLINK=
endif

REDIS_CC=$(QUIET_CC)$(CC) $(FINAL_CFLAGS)
REDIS_LD=$(QUIET_LINK)$(CC) $(FINAL_LDFLAGS)
REDIS_INSTALL=$(QUIET_INSTALL)$(INSTALL)

CCCOLOR="\033[34m"
LINKCOLOR="\033[34;1m"
SRCCOLOR="\033[33m"
BINCOLOR="\033[37;1m"
MAKECOLOR="\033[32;1m"
ENDCOLOR="\033[0m"

ifndef V
QUIET_CC = @printf '    %b %b\n' $(CCCOLOR)CC$(ENDCOLOR) $(SRCCOLOR)$@$(ENDCOLOR) 1>&2;
QUIET_GEN = @printf '    %b %b\n' $(CCCOLOR)GEN$(ENDCOLOR) $(SRCCOLOR)$@$(ENDCOLOR) 1>&2;
QUIET_LINK = @printf '    %b %b\n' $(LINKCOLOR)LINK$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR) 1>&2;
QUIET_INSTALL = @printf '    %b %b\n' $(LINKCOLOR)INSTALL$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR) 1>&2;
endif

ifneq (, $(findstring LOG_REQ_RES, $(SERVER_CFLAGS)))
	COMMANDS_DEF_FILENAME=commands_with_reply_schema
	GEN_COMMANDS_FLAGS=--with-reply-schema
else
	COMMANDS_DEF_FILENAME=commands
	GEN_COMMANDS_FLAGS=
endif

ENGINE_NAME=valkey
REDIS_SERVER_NAME=valkey-server$(PROG_SUFFIX)
REDIS_SENTINEL_NAME=valkey-sentinel$(PROG_SUFFIX)
REDIS_SERVER_OBJ=adlist.o quicklist.o ae.o anet.o dict.o server.o sds.o zmalloc.o lzf_c.o lzf_d.o pqsort.o zipmap.o sha1.o ziplist.o release.o networking.o util.o object.o db.o replication.o rdb.o t_string.o t_list.o t_set.o t_zset.o t_hash.o config.o aof.o pubsub.o multi.o debug.o sort.o intset.o syncio.o cluster.o crc16.o endianconv.o slowlog.o eval.o bio.o rio.o rand.o memtest.o syscheck.o crcspeed.o crc64.o bitops.o sentinel.o notify.o setproctitle.o blocked.o hyperloglog.o latency.o sparkline.o valkey-check-rdb.o valkey-check-aof.o geo.o lazyfree.o module.o evict.o expire.o geohash.o geohash_helper.o childinfo.o defrag.o siphash.o rax.o t_stream.o listpack.o localtime.o lolwut.o lolwut5.o lolwut6.o acl.o tracking.o socket.o tls.o sha256.o timeout.o setcpuaffinity.o monotonic.o mt19937-64.o resp_parser.o call_reply.o script_lua.o script.o functions.o function_lua.o commands.o strl.o connection.o unix.o logreqres.o
REDIS_CLI_NAME=valkey-cli$(PROG_SUFFIX)
REDIS_CLI_OBJ=anet.o adlist.o dict.o valkey-cli.o zmalloc.o release.o ae.o redisassert.o crcspeed.o crc64.o siphash.o crc16.o monotonic.o cli_common.o mt19937-64.o strl.o cli_commands.o
REDIS_BENCHMARK_NAME=valkey-benchmark$(PROG_SUFFIX)

=== debian/changelog ===
valkey (7.2.5+dfsg1-2ubuntu4~24.04.1) noble; urgency=medium

  * Backport from Oracular to Noble (LP: #2081000).

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Fri, 20 Sep 2024 20:19:57 -0300

valkey (7.2.5+dfsg1-2ubuntu4) oracular; urgency=medium

  * d/watch: Fix dversionmangle.
  * d/rules: remove "|| true" from testing calls.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Fri, 20 Sep 2024 17:10:49 -0300

valkey (7.2.5+dfsg1-2ubuntu3) oracular; urgency=medium

  * d/t/0006-migrate-from-redis: fix the way the compat package is installed
    during the test.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Wed, 18 Sep 2024 12:25:38 -0300

valkey (7.2.5+dfsg1-2ubuntu2) oracular; urgency=medium

  * d/valkey-redis-compat.postinst:
    - Use "cp -a" to preserve permissions and keep old data around.
    - Stop daemons before perfoming migration.
  * d/tests: use systemctl instead of service to restart valkey.
  * d/t/control: explicitly add Depends for each test.
  * d/t/0006-migrate-from-redis:
    - Print the checksum of the RDB file.
    - Make sure data in-memory is on-disk when migrating data.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Tue, 17 Sep 2024 19:17:44 -0300

valkey (7.2.5+dfsg1-2ubuntu1) oracular; urgency=medium

  * d/control: add valkey-redis-compat binary package paragraph
  * d/valkey-redis-compat.postinst: migrate data and config from Redis
  * d/bin/generate-systemd-service-files: do not start the services if Redis
    migration happened.
  * d/{README.Debian,valkey-redis-compat.NEWS}: document how the Redis
    migration works.
  * d/valkey-redis-compat.links: create compatibility symlinks for Redis
  * d/tests: test Redis migration via DEP-8 test

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Mon, 12 Aug 2024 19:30:23 -0300

valkey (7.2.5+dfsg1-2) unstable; urgency=medium

  * d/copyright: remove the excluded files paragraph.
  * d/copyright: add missing License field.
  * d/watch: add version mangle and repack suffix because of dfsg.

 -- Lucas Kanashiro <kanashiro@debian.org>  Fri, 09 Aug 2024 19:01:26 -0300

valkey (7.2.5+dfsg1-1) unstable; urgency=medium

  * Initial packaging (Closes: #1068342).

 -- Lucas Kanashiro <kanashiro@debian.org>  Wed, 26 Jun 2024 18:35:47 -0300

=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg1//,repacksuffix=+dfsg,filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
  https://github.com/valkey-io/valkey/tags \
  (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## valkey 7.2.7+dfsg1

=== debian/changelog ===
valkey (7.2.7+dfsg1-0ubuntu0.24.10.1) oracular; urgency=medium

  * New upstream version 7.2.7 (LP: #2091129)
    - Security fixes:
      + CVE-2024-31449: Lua library commands may lead to stack overflow and
        potential RCE.
      + CVE-2024-31227: Potential Denial-of-service due to malformed ACL
        selectors.
      + CVE-2024-31228: Potential Denial-of-service due to unbounded pattern
        matching.
    - Bug fixes:
      + Fix re-enable of Append-Only File flag in RdbLoad module.
      + Fix cluster replica failure to establish replication link in race
        condition.
      + Fix valkeymodule-rs build issues due to typo in REGISTER_API.
      + Fix crash where command duration is not reset when client is blocked.
      + Fix CLUSTER SHARDS empty array return.
      + Fix client auth block when a cluster is down.
      + Fix MEET request reliability during link failure.
      + Ensure the --count option in redis-cli works correctly even without
        --pattern.
      + Fix redis-check-aof misidentifying data in manifest format as MP-AOF.
    - Updates:
      + Add clusterNodeIsVotingPrimary concept to fix issue where nodes outside
        the quorum group could mark nodes as failed.
      + Add compatibility with redis-sentinel for starting sentinel.
      + Update redis-check-rdb types to replace stream-v2 with stream-v3
  * d/watch: Fix repack suffix

 -- Lena Voytek <lena.voytek@canonical.com>  Thu, 05 Dec 2024 15:24:35 -0700

## valkey 7.2.8+dfsg1

=== debian/changelog ===
valkey (7.2.8+dfsg1-0ubuntu0.24.04.2) noble-security; urgency=medium

  * No-change rebuild in the ~security pocket 

 -- Julia Sarris <julia.sarris@canonical.com>  Mon, 03 Mar 2025 10:25:22 -0500

valkey (7.2.8+dfsg1-0ubuntu0.24.04.1) noble; urgency=medium

  * New upstream version 7.2.8 (LP: #2097546)
    - Security fixes:
      + CVE-2024-46981: Lua script commands may lead to remote code
        execution.
      + CVE-2024-51741: Denial-of-service due to malformed ACL
        selectors.
    - Bug fixes:
      + Fix extra memory use when storing strings in inline protocol.
      + Fix error message when FUNCTION KILL is used on a script.
      + Fix last accessed time update using TOUCH with CLIENT NO-TOUCH
        option.

 -- Lena Voytek <lena.voytek@canonical.com>  Thu, 06 Feb 2025 08:58:24 -0500

valkey (7.2.7+dfsg1-0ubuntu0.24.04.1) noble; urgency=medium

  * New upstream version 7.2.7 (LP: #2091129)
    - Security fixes:
      + CVE-2024-31449: Lua library commands may lead to stack overflow and
        potential RCE.
      + CVE-2024-31227: Potential Denial-of-service due to malformed ACL
        selectors.
      + CVE-2024-31228: Potential Denial-of-service due to unbounded pattern
        matching.
    - Bug fixes:
      + Fix re-enable of Append-Only File flag in RdbLoad module.
      + Fix cluster replica failure to establish replication link in race
        condition.
      + Fix valkeymodule-rs build issues due to typo in REGISTER_API.
      + Fix crash where command duration is not reset when client is blocked.
      + Fix CLUSTER SHARDS empty array return.
      + Fix client auth block when a cluster is down.
      + Fix MEET request reliability during link failure.
      + Ensure the --count option in redis-cli works correctly even without
        --pattern.
      + Fix redis-check-aof misidentifying data in manifest format as MP-AOF.
    - Updates:
      + Add clusterNodeIsVotingPrimary concept to fix issue where nodes outside
        the quorum group could mark nodes as failed.
      + Add compatibility with redis-sentinel for starting sentinel.
      + Update redis-check-rdb types to replace stream-v2 with stream-v3
  * d/watch: Fix repack suffix

 -- Lena Voytek <lena.voytek@canonical.com>  Thu, 05 Dec 2024 14:44:44 -0700

=== debian/control ===
Source: valkey
Section: database
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Lucas Kanashiro <kanashiro@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 libhiredis-dev,
 libjemalloc-dev [linux-any],
 liblua5.1-dev,
 liblzf-dev,
 libssl-dev,
 libsystemd-dev,
 lua-bitop-dev,
 lua-cjson-dev,
 openssl <!nocheck>,
 pkgconf,
 procps <!nocheck>,
 tcl <!nocheck>,
 tcl-tls <!nocheck>,
Standards-Version: 4.7.0
Homepage: https://valkey.io
Vcs-Git: https://salsa.debian.org/debian/valkey.git
Vcs-Browser: https://salsa.debian.org/debian/valkey
Rules-Requires-Root: no

Package: valkey-redis-compat
Architecture: all
Depends: valkey-server
Conflicts: redis-server, redis-tools, redis-sentinel
Replaces: redis-server, redis-tools, redis-sentinel
Description: Conversion script and compatibility symlinks for Redis
 Automation of the migration of data and configuration from Redis to Valkey.

Package: valkey-server
Provides: valkey
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 valkey-tools (= ${binary:Version}),
 ${misc:Depends},
Description: Persistent key-value database with network interface
 Valkey is a key-value database in a similar vein to memcache but the dataset
 is non-volatile. Valkey additionally provides native support for atomically
 manipulating and querying data structures such as lists and sets.
 .
 The dataset is stored entirely in memory and periodically flushed to disk.

Package: valkey-sentinel
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 valkey-tools (= ${binary:Version}),
 ${misc:Depends},
Description: Persistent key-value database with network interface (monitoring)
 Valkey is a key-value database in a similar vein to memcache but the dataset
 is non-volatile. Valkey additionally provides native support for atomically
 manipulating and querying data structures such as lists and sets.
 .
 This package contains the Valkey Sentinel monitoring software.

Package: valkey-tools
Architecture: any
Depends:
 adduser,
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 ruby-redis,
Description: Persistent key-value database with network interface (client)
 Valkey is a key-value database in a similar vein to memcache but the dataset
 is non-volatile. Valkey additionally provides native support for atomically
 manipulating and querying data structures such as lists and sets.
 .
 This package contains the command line client and other tools.

## valkey 7.2.10+dfsg1

=== src/Makefile ===
--- 
+++ 
@@ -342,7 +342,6 @@
 ifeq ($(USE_REDIS_SYMLINKS),yes)
 	MAYBE_INSTALL_REDIS_SYMLINK=$(INSTALL_REDIS_SYMLINK)
 	MAYBE_UNINSTALL_REDIS_SYMLINK=@rm -f $(1)/$(subst $(ENGINE_NAME),redis,$(2))
-	FINAL_CFLAGS+= -DUSE_REDIS_SYMLINKS
 else
 	MAYBE_INSTALL_REDIS_SYMLINK=
 	MAYBE_UNINSTALL_REDIS_SYMLINK=

=== debian/changelog ===
valkey (7.2.10+dfsg1-0ubuntu0.1) noble; urgency=medium

  * New upstream version 7.2.10 (LP: #2115258)
    - Security fixes:
      + CVE-2025-21605: Allocation of Resources Without Limits or Throttling.
      + CVE-2025-32023: Out-of-bounds write during hyperloglog operations.
      + CVE-2025-48367: IP Protocol errors resulting in DoS.
      + CVE-2025-27151: AOF file name length not checked.
    - Bug fixes:
      + Only mark the client reprocessing flag when unblocked on keys.
      + Free module context even if there was no content written in auxsave2.
      + Fix Detect SSL_new() returning NULL in outgoing connections.
      + Correctly cast the extension lengths.
      + Fix cluster myself CLUSTER SLOTS/NODES wrong port after updating
        port/tls-port.
      + Fix replica can't finish failover when config epoch is outdated.
      + Fix CLIENT UNBLOCK ability to unpause paused clients.
      + Fix defrag crash when using FLUSHDB ASYNC in cluster mode.
      + Fix memory leak in forgotten node ping ext code path.
      + Fix module LatencyAddSample still work when latency-monitor-threshold
        is 0.
      + Fix raxRemove crash at memcpy() due to key size exceeds max Rax size.
      + Fix error "SSL routines::bad length" when connTLSWrite is called second
        time with smaller buffer.
      + Fix RANDOMKEY infinite loop during CLIENT PAUSE.
      + Fix adding samples to stream object consumer trees.
      + Fix panic in primary when blocking shutdown after previous block with
        timeout.
      + Fix incorrect lag reported in XINFO GROUPS.

 -- Lena Voytek <lena.voytek@canonical.com>  Tue, 24 Jun 2025 15:08:25 -0400

valkey (7.2.8+dfsg1-0ubuntu0.24.04.3) noble; urgency=medium

  * d/valkey-redis-compat.postinst: Do not migrate on upgrade if redis files
    have already been migrated (LP: #2104217).

 -- Lena Voytek <lena.voytek@canonical.com>  Wed, 18 Jun 2025 16:58:33 -0400

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export BUILD_TLS = yes
export CFLAGS CPPFLAGS LDFLAGS
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -I/usr/include/liblzf
export DEB_LDFLAGS_MAINT_APPEND = -Wl,-no-as-needed -ldl -latomic -llzf

# Build jemelloc in parallel
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
	export MAKEFLAGS
endif

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean
	rm -f src/release.h debian/*.service

override_dh_auto_build:
	dh_auto_build -- V=1 USE_SYSTEM_JEMALLOC=yes USE_SYSTEMD=yes USE_JEMALLOC=yes

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Generate a root CA and server certificate for testing
	./utils/gen-test-certs.sh
	# Avoid race conditions in upstream testsuite
	./runtest --clients 1 --verbose --dump-logs --tls
	timeout 30m ./runtest-cluster --tls
	./runtest-sentinel
	# Clean up after gen-test-certs.sh
	rm -rf tests/tls || true
	# Other cleanup
	find tests/tmp ! -name .gitignore -type f -exec rm -rfv {} +
endif

override_dh_auto_install:
	debian/bin/generate-systemd-service-files

override_dh_compress:
	dh_compress -Xredis-trib.rb

override_dh_installchangelogs:
	dh_installchangelogs --keep 00-RELEASENOTES

=== debian/tests/control ===
Tests: 0001-valkey-cli
Depends: valkey-server
Restrictions: needs-root

Tests: 0002-benchmark
Depends: valkey-server
Restrictions: needs-root

Tests: 0003-valkey-check-aof
Depends: valkey-server
Restrictions: needs-root

Tests: 0004-valkey-check-rdb
Depends: valkey-server
Restrictions: needs-root

Tests: 0005-cjson
Depends: valkey-server
Restrictions: needs-root

Tests: 0006-migrate-from-redis
Depends: redis-server, redis-sentinel
Restrictions: needs-root, allow-stderr

## valkey 7.2.11+dfsg1

=== deps/fpconv/Makefile ===
STD=
WARN= -Wall
OPT= -Os

R_CFLAGS= $(STD) $(WARN) $(OPT) $(DEBUG) $(CFLAGS)
R_LDFLAGS= $(LDFLAGS)
DEBUG= -g

R_CC=$(CC) $(R_CFLAGS)
R_LD=$(CC) $(R_LDFLAGS)

AR= ar
ARFLAGS= rcs

libfpconv.a: fpconv_dtoa.o
	$(AR) $(ARFLAGS) $@ $+

fpconv_dtoa.o: fpconv_dtoa.h fpconv_dtoa.c

.c.o:
	$(R_CC) -c  $< 

clean:
	rm -f *.o
	rm -f *.a

=== debian/changelog ===
valkey (7.2.11+dfsg1-0ubuntu0.1) noble; urgency=medium

  * New upstream version 7.2.11 (LP: #2127122)
    - Security fixes:
      + CVE-2025-49844: Lua script may lead to remote code execution.
      + CVE-2025-46817: Lua script may lead to int overflow and potential RCE.
      + CVE-2025-46818: Lua script can be executed in context of another user.
      + CVE-2025-46819: LUA out-of-bound read.
      + CVE-2025-49112: Integer underflow in setDeferredReply networking.c.
    - Bug fixes:
      + Ensure empty error tables in scripts don't crash Valkey.
      + Fix client tracking memory overhead calculation.
      + Fix assumptions that pthread functions set errno.
  * d/rules: Increase test timeout during build.

 -- Lena Voytek <lena.voytek@canonical.com>  Sat, 11 Oct 2025 23:49:31 -0400

=== debian/rules ===
--- 
+++ 
@@ -32,7 +32,7 @@
 	./utils/gen-test-certs.sh
 	# Avoid race conditions in upstream testsuite
 	./runtest --clients 1 --verbose --dump-logs --tls
-	timeout 30m ./runtest-cluster --tls
+	timeout 60m ./runtest-cluster --tls
 	./runtest-sentinel
 	# Clean up after gen-test-certs.sh
 	rm -rf tests/tls || true

## valkey 7.2.12+dfsg1

=== debian/changelog ===
valkey (7.2.12+dfsg1-0ubuntu0.1) noble; urgency=medium

  * New upstream version 7.2.12 (LP: #2142590)
    - Security fixes:
        + CVE-2025-67733: RESP Protocol Injection via Lua error_reply.
        + CVE-2026-21863: Remote DoS with malformed Valkey Cluster bus message.
    - Bug fixes:
        + Fix ltrim should not call signalModifiedKey when no elements are
          removed.
        + Fix potential infinite loop in clusterNodeGetMaster.
        + Avoids crash during MODULE UNLOAD when ACL rules reference a module
          command and subcommand.

 -- Lena Voytek <lena.voytek@canonical.com>  Tue, 24 Feb 2026 09:01:01 -0500

valkey (7.2.11+dfsg1-0ubuntu0.2) noble-security; urgency=medium

  * No change rebuild to copy previous update to the security pocket.

 -- Hlib Korzhynskyy <hlib.korzhynskyy@canonical.com>  Wed, 19 Nov 2025 13:39:49 -0330

## valkey 8.0.1+dfsg1

=== src/modules/Makefile ===

# find the OS
uname_S := $(shell sh -c 'uname -s 2>/dev/null || echo not')

# Compile flags for linux / osx
ifeq ($(uname_S),Linux)
	SHOBJ_CFLAGS ?= -W -Wall -fno-common -g -ggdb -std=c99 -O2
	SHOBJ_LDFLAGS ?= -shared
else
	SHOBJ_CFLAGS ?= -W -Wall -dynamic -fno-common -g -ggdb -std=c99 -O2
	SHOBJ_LDFLAGS ?= -bundle -undefined dynamic_lookup
endif

# OS X 11.x doesn't have /usr/lib/libSystem.dylib and needs an explicit setting.
ifeq ($(uname_S),Darwin)
ifeq ("$(wildcard /usr/lib/libSystem.dylib)","")
LIBS = -L /Library/Developer/CommandLineTools/SDKs/MacOSX.sdk/usr/lib -lsystem
endif
endif

.SUFFIXES: .c .so .xo .o

all: helloworld.so hellotype.so helloblock.so hellocluster.so hellotimer.so hellodict.so hellohook.so helloacl.so

.c.xo:
	$(CC) -I. $(CFLAGS) $(SHOBJ_CFLAGS) -fPIC -c $< -o $@

helloworld.xo: ../valkeymodule.h

helloworld.so: helloworld.xo
	$(LD) -o $@ $^ $(SHOBJ_LDFLAGS) $(LIBS) -lc

hellotype.xo: ../valkeymodule.h

hellotype.so: hellotype.xo
	$(LD) -o $@ $^ $(SHOBJ_LDFLAGS) $(LIBS) -lc

helloblock.xo: ../valkeymodule.h

helloblock.so: helloblock.xo
	$(LD) -o $@ $^ $(SHOBJ_LDFLAGS) $(LIBS) -lpthread -lc

hellocluster.xo: ../valkeymodule.h

hellocluster.so: hellocluster.xo
	$(LD) -o $@ $^ $(SHOBJ_LDFLAGS) $(LIBS) -lc

hellotimer.xo: ../valkeymodule.h

hellotimer.so: hellotimer.xo
	$(LD) -o $@ $^ $(SHOBJ_LDFLAGS) $(LIBS) -lc

hellodict.xo: ../valkeymodule.h

hellodict.so: hellodict.xo
	$(LD) -o $@ $^ $(SHOBJ_LDFLAGS) $(LIBS) -lc

hellohook.xo: ../valkeymodule.h

hellohook.so: hellohook.xo
	$(LD) -o $@ $^ $(SHOBJ_LDFLAGS) $(LIBS) -lc

helloacl.xo: ../valkeymodule.h

helloacl.so: helloacl.xo
	$(LD) -o $@ $^ $(SHOBJ_LDFLAGS) $(LIBS) -lc

clean:
	rm -rf *.xo *.so

=== debian/changelog ===
valkey (8.0.1+dfsg1-1~bpo12+1) UNRELEASED; urgency=medium

  * bookworm-backports Rebuilt for bookworm.

 -- Lucas Kanashiro <kanashiro@debian.org>  Mon, 04 Nov 2024 11:19:23 +0000

valkey (8.0.1+dfsg1-1) unstable; urgency=medium

  [ Lena Voytek ]
  * New upstream release 8.0.1
  * Refresh patches against new version:
    - d/p/debian-packaging/0001-Set-Debian-configuration-defaults.patch
    - d/p/0002-Add-CPPFLAGS-to-upstream-makefiles.patch
    - d/p/0003-Use-get_current_dir_name-over-PATHMAX.patch
    - d/p/0004-Add-support-for-USE_SYSTEM_JEMALLOC-flag.patch
  * d/valkey-server.docs: Remove MANIFESTO
  * d/valkey-tools.examples: Remove redis-trib.rb

  [ Lucas Kanashiro ]
  * d/copyright: remove superfluous file pattern

 -- Lucas Kanashiro <kanashiro@debian.org>  Fri, 18 Oct 2024 19:23:21 -0300

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: valkey
 Section: database
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Lucas Kanashiro <kanashiro@debian.org>
+Maintainer: Lucas Kanashiro <kanashiro@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  libhiredis-dev,
@@ -23,14 +22,6 @@
 Vcs-Git: https://salsa.debian.org/debian/valkey.git
 Vcs-Browser: https://salsa.debian.org/debian/valkey
 Rules-Requires-Root: no
-
-Package: valkey-redis-compat
-Architecture: all
-Depends: valkey-server
-Conflicts: redis-server, redis-tools, redis-sentinel
-Replaces: redis-server, redis-tools, redis-sentinel
-Description: Conversion script and compatibility symlinks for Redis
- Automation of the migration of data and configuration from Redis to Valkey.
 
 Package: valkey-server
 Provides: valkey

## valkey 8.0.2+dfsg1

=== debian/changelog ===
valkey (8.0.2+dfsg1-1ubuntu1) plucky; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - Redis compatibility and migration:
      + d/bin/generate-systemd-service-files: do not start the services if
        Redis migration happened.
      + d/control: add valkey-redis-compat binary package paragraph
      + d/{README.Debian,valkey-redis-compat.NEWS}: document how the Redis
        migration works.
      + d/valkey-redis-compat.links: create compatibility symlinks for Redis
      + d/valkey-redis-compat.postinst: migrate data and config from Redis
      + d/tests: test Redis migration via DEP-8 test
    - d/tests: use systemctl instead of service to restart valkey.
    - d/t/control: explicitly add Depends for each test.
    - d/rules: remove "|| true" from testing calls.

 -- Lena Voytek <lena.voytek@canonical.com>  Thu, 06 Feb 2025 14:25:07 -0500

valkey (8.0.2+dfsg1-1) unstable; urgency=medium

  [ Christian Göttsche ]
  * 0003-Use-get_current_dir_name-over-PATHMAX.patch: free allocated memory
  * d/rules: enable LTO
  * valkey-tools.postinst: create directories with default SELinux context

  [ Lucas Kanashiro ]
  * New upstream version 8.0.2+dfsg1
    - Fixes CVE-2024-46981 and CVE-2024-51741 (Closes: #1092371)

 -- Lucas Kanashiro <kanashiro@debian.org>  Mon, 13 Jan 2025 23:55:00 -0300

valkey (8.0.1+dfsg1-1ubuntu1) plucky; urgency=medium

  * Merge with Debian unstable (LP: #2085304). Remaining changes:
    - Redis compatibility and migration:
      + d/bin/generate-systemd-service-files: do not start the services if
        Redis migration happened.
      + d/control: add valkey-redis-compat binary package paragraph
      + d/{README.Debian,valkey-redis-compat.NEWS}: document how the Redis
        migration works.
      + d/valkey-redis-compat.links: create compatibility symlinks for Redis
      + d/valkey-redis-compat.postinst: migrate data and config from Redis
      + d/tests: test Redis migration via DEP-8 test
    - d/tests: use systemctl instead of service to restart valkey.
    - d/t/control: explicitly add Depends for each test.
    - d/rules: remove "|| true" from testing calls.

 -- Lena Voytek <lena.voytek@canonical.com>  Tue, 22 Oct 2024 11:02:02 -0700

=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg1//,repacksuffix=+dfsg1,filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
  https://github.com/valkey-io/valkey/tags \
  (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## valkey 8.0.4+dfsg1

=== debian/changelog ===
valkey (8.0.4+dfsg1-0ubuntu0.1) plucky; urgency=medium

  * New upstream version 8.0.4 (LP: #2115258)
    - Security fixes:
      + CVE-2025-21605: Allocation of Resources Without Limits or Throttling.
      + CVE-2025-32023: Out-of-bounds write during hyperloglog operations
      + CVE-2025-48367: IP Protocol errors resulting in DoS
    - Bug fixes:
      + Optimize RDB Load Performance and Fix Cluster Mode Resizing.
      + Fix memory leak in forgotten node ping ext code path.
      + Fix cluster info sent stats for message with light header.
      + Fix module LatencyAddSample still work when latency-monitor-threshold
        is 0.
      + Fix raxRemove crash at memcpy() due to key size exceeds max Rax size.
      + Fix error "SSL routines::bad length" when connTLSWrite is called
        second time with smaller buffer.
      + Fix temp file leak druing replication error handling.
      + Fix ACL LOAD crash on replica since the primary client don't has a
        user.
      + Fix RANDOMKEY infinite loop during CLIENT PAUSE.
      + Fix adding samples to stream object consumer trees.
      + Fix cluster slot stats assertion during promotion of replica.
      + Fix panic in primary when blocking shutdown after previous block with
        timeout.
      + Ignore stale gossip packets that arrive out of order.
      + Fix incorrect lag reported in XINFO GROUPS.
      + Avoid shard id update of replica if not matching with primary shard id.

 -- Lena Voytek <lena.voytek@canonical.com>  Tue, 24 Jun 2025 14:45:07 -0400

valkey (8.0.2+dfsg1-1ubuntu2) plucky; urgency=medium

  * d/valkey-redis-compat.postinst: Do not migrate on upgrade if redis files
    have already been migrated (LP: #2104217).

 -- Lena Voytek <lena.voytek@canonical.com>  Wed, 18 Jun 2025 16:50:06 -0400

## valkey 8.0.6%2Bdfsg1

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 export BUILD_TLS = yes
 export CFLAGS CPPFLAGS LDFLAGS
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=+lto
 export DEB_CFLAGS_MAINT_APPEND = -I/usr/include/liblzf
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,-no-as-needed -ldl -latomic -llzf
 
@@ -32,7 +32,7 @@
 	./utils/gen-test-certs.sh
 	# Avoid race conditions in upstream testsuite
 	./runtest --clients 1 --verbose --dump-logs --tls
-	timeout 60m ./runtest-cluster --tls
+	timeout 30m ./runtest-cluster --tls
 	./runtest-sentinel
 	# Clean up after gen-test-certs.sh
 	rm -rf tests/tls || true
